<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/backtrace-0.3.66/src/backtrace/libunwind.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>libunwind.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../backtrace/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
</pre><pre class="rust"><code><span class="doccomment">//! Backtrace support using libunwind/gcc_s/etc APIs.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This module contains the ability to unwind the stack using libunwind-style</span>
<span class="doccomment">//! APIs. Note that there&#39;s a whole bunch of implementations of the</span>
<span class="doccomment">//! libunwind-like API, and this is just trying to be compatible with most of</span>
<span class="doccomment">//! them all at once instead of being picky.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The libunwind API is powered by `_Unwind_Backtrace` and is in practice very</span>
<span class="doccomment">//! reliable at generating a backtrace. It&#39;s not entirely clear how it does it</span>
<span class="doccomment">//! (frame pointers? eh_frame info? both?) but it seems to work!</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Most of the complexity of this module is handling the various platform</span>
<span class="doccomment">//! differences across libunwind implementations. Otherwise this is a pretty</span>
<span class="doccomment">//! straightforward Rust binding to the libunwind APIs.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This is the default unwinding API for all non-Windows platforms currently.</span>

<span class="kw">use</span> <span class="ident"><span class="kw">super</span>::<span class="kw">super</span>::Bomb</span>;
<span class="kw">use</span> <span class="ident">core::ffi::c_void</span>;

<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Frame</span> {
    <span class="ident">Raw</span>(<span class="kw-2">*mut</span> <span class="ident">uw::_Unwind_Context</span>),
    <span class="ident">Cloned</span> {
        <span class="ident">ip</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
        <span class="ident">sp</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
        <span class="ident">symbol_address</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
    },
}

<span class="comment">// With a raw libunwind pointer it should only ever be access in a readonly</span>
<span class="comment">// threadsafe fashion, so it&#39;s `Sync`. When sending to other threads via `Clone`</span>
<span class="comment">// we always switch to a version which doesn&#39;t retain interior pointers, so we</span>
<span class="comment">// should be `Send` as well.</span>
<span class="kw">unsafe</span> <span class="kw">impl</span> <span class="ident">Send</span> <span class="kw">for</span> <span class="ident">Frame</span> {}
<span class="kw">unsafe</span> <span class="kw">impl</span> <span class="ident">Sync</span> <span class="kw">for</span> <span class="ident">Frame</span> {}

<span class="kw">impl</span> <span class="ident">Frame</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">ip</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">c_void</span> {
        <span class="kw">let</span> <span class="ident">ctx</span> <span class="op">=</span> <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">Frame::Raw</span>(<span class="ident">ctx</span>) =&gt; <span class="ident">ctx</span>,
            <span class="ident">Frame::Cloned</span> { <span class="ident">ip</span>, .. } =&gt; <span class="kw">return</span> <span class="ident">ip</span>,
        };
        <span class="kw">unsafe</span> { <span class="ident">uw::_Unwind_GetIP</span>(<span class="ident">ctx</span>) <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">c_void</span> }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">sp</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">c_void</span> {
        <span class="kw">match</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="ident">Frame::Raw</span>(<span class="ident">ctx</span>) =&gt; <span class="kw">unsafe</span> { <span class="ident">uw::get_sp</span>(<span class="ident">ctx</span>) <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">c_void</span> },
            <span class="ident">Frame::Cloned</span> { <span class="ident">sp</span>, .. } =&gt; <span class="ident">sp</span>,
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">symbol_address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">c_void</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="ident">Frame::Cloned</span> { <span class="ident">symbol_address</span>, .. } <span class="op">=</span> <span class="kw-2">*</span><span class="self">self</span> {
            <span class="kw">return</span> <span class="ident">symbol_address</span>;
        }

        <span class="comment">// The macOS linker emits a &quot;compact&quot; unwind table that only includes an</span>
        <span class="comment">// entry for a function if that function either has an LSDA or its</span>
        <span class="comment">// encoding differs from that of the previous entry.  Consequently, on</span>
        <span class="comment">// macOS, `_Unwind_FindEnclosingFunction` is unreliable (it can return a</span>
        <span class="comment">// pointer to some totally unrelated function).  Instead, we just always</span>
        <span class="comment">// return the ip.</span>
        <span class="comment">//</span>
        <span class="comment">// https://github.com/rust-lang/rust/issues/74771#issuecomment-664056788</span>
        <span class="comment">//</span>
        <span class="comment">// Note the `skip_inner_frames.rs` test is skipped on macOS due to this</span>
        <span class="comment">// clause, and if this is fixed that test in theory can be run on macOS!</span>
        <span class="kw">if</span> <span class="macro">cfg!</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;macos&quot;</span>) <span class="op">|</span><span class="op">|</span> <span class="macro">cfg!</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;ios&quot;</span>) {
            <span class="self">self</span>.<span class="ident">ip</span>()
        } <span class="kw">else</span> {
            <span class="kw">unsafe</span> { <span class="ident">uw::_Unwind_FindEnclosingFunction</span>(<span class="self">self</span>.<span class="ident">ip</span>()) }
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">module_base_address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">*mut</span> <span class="ident">c_void</span><span class="op">&gt;</span> {
        <span class="prelude-val">None</span>
    }
}

<span class="kw">impl</span> <span class="ident">Clone</span> <span class="kw">for</span> <span class="ident">Frame</span> {
    <span class="kw">fn</span> <span class="ident">clone</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Frame</span> {
        <span class="ident">Frame::Cloned</span> {
            <span class="ident">ip</span>: <span class="self">self</span>.<span class="ident">ip</span>(),
            <span class="ident">sp</span>: <span class="self">self</span>.<span class="ident">sp</span>(),
            <span class="ident">symbol_address</span>: <span class="self">self</span>.<span class="ident">symbol_address</span>(),
        }
    }
}

<span class="attribute">#[<span class="ident">inline</span>(<span class="ident">always</span>)]</span>
<span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">trace</span>(<span class="kw-2">mut</span> <span class="ident">cb</span>: <span class="kw-2">&amp;mut</span> <span class="kw">dyn</span> <span class="ident">FnMut</span>(<span class="kw-2">&amp;</span><span class="ident"><span class="kw">super</span>::Frame</span>) -&gt; <span class="ident">bool</span>) {
    <span class="ident">uw::_Unwind_Backtrace</span>(<span class="ident">trace_fn</span>, <span class="kw-2">&amp;mut</span> <span class="ident">cb</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="kw">_</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="kw">_</span>);

    <span class="kw">extern</span> <span class="string">&quot;C&quot;</span> <span class="kw">fn</span> <span class="ident">trace_fn</span>(
        <span class="ident">ctx</span>: <span class="kw-2">*mut</span> <span class="ident">uw::_Unwind_Context</span>,
        <span class="ident">arg</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
    ) -&gt; <span class="ident">uw::_Unwind_Reason_Code</span> {
        <span class="kw">let</span> <span class="ident">cb</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="kw-2">&amp;mut</span> <span class="kw-2">*</span>(<span class="ident">arg</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="kw-2">&amp;mut</span> <span class="kw">dyn</span> <span class="ident">FnMut</span>(<span class="kw-2">&amp;</span><span class="ident"><span class="kw">super</span>::Frame</span>) -&gt; <span class="ident">bool</span>) };
        <span class="kw">let</span> <span class="ident">cx</span> <span class="op">=</span> <span class="ident"><span class="kw">super</span>::Frame</span> {
            <span class="ident">inner</span>: <span class="ident">Frame::Raw</span>(<span class="ident">ctx</span>),
        };

        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">bomb</span> <span class="op">=</span> <span class="ident">Bomb</span> { <span class="ident">enabled</span>: <span class="bool-val">true</span> };
        <span class="kw">let</span> <span class="ident">keep_going</span> <span class="op">=</span> <span class="ident">cb</span>(<span class="kw-2">&amp;</span><span class="ident">cx</span>);
        <span class="ident">bomb</span>.<span class="ident">enabled</span> <span class="op">=</span> <span class="bool-val">false</span>;

        <span class="kw">if</span> <span class="ident">keep_going</span> {
            <span class="ident">uw::_URC_NO_REASON</span>
        } <span class="kw">else</span> {
            <span class="ident">uw::_URC_FAILURE</span>
        }
    }
}

<span class="doccomment">/// Unwind library interface used for backtraces</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Note that dead code is allowed as here are just bindings</span>
<span class="doccomment">/// iOS doesn&#39;t use all of them it but adding more</span>
<span class="doccomment">/// platform-specific configs pollutes the code too much</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">non_camel_case_types</span>)]</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">non_snake_case</span>)]</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="kw">mod</span> <span class="ident">uw</span> {
    <span class="kw">pub</span> <span class="kw">use</span> <span class="ident"><span class="self">self</span>::_Unwind_Reason_Code</span>::<span class="kw-2">*</span>;

    <span class="kw">use</span> <span class="ident">core::ffi::c_void</span>;

    <span class="attribute">#[<span class="ident">repr</span>(<span class="ident">C</span>)]</span>
    <span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">_Unwind_Reason_Code</span> {
        <span class="ident">_URC_NO_REASON</span> <span class="op">=</span> <span class="number">0</span>,
        <span class="ident">_URC_FOREIGN_EXCEPTION_CAUGHT</span> <span class="op">=</span> <span class="number">1</span>,
        <span class="ident">_URC_FATAL_PHASE2_ERROR</span> <span class="op">=</span> <span class="number">2</span>,
        <span class="ident">_URC_FATAL_PHASE1_ERROR</span> <span class="op">=</span> <span class="number">3</span>,
        <span class="ident">_URC_NORMAL_STOP</span> <span class="op">=</span> <span class="number">4</span>,
        <span class="ident">_URC_END_OF_STACK</span> <span class="op">=</span> <span class="number">5</span>,
        <span class="ident">_URC_HANDLER_FOUND</span> <span class="op">=</span> <span class="number">6</span>,
        <span class="ident">_URC_INSTALL_CONTEXT</span> <span class="op">=</span> <span class="number">7</span>,
        <span class="ident">_URC_CONTINUE_UNWIND</span> <span class="op">=</span> <span class="number">8</span>,
        <span class="ident">_URC_FAILURE</span> <span class="op">=</span> <span class="number">9</span>, <span class="comment">// used only by ARM EABI</span>
    }

    <span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">_Unwind_Context</span> {}

    <span class="kw">pub</span> <span class="kw">type</span> <span class="ident">_Unwind_Trace_Fn</span> <span class="op">=</span>
        <span class="kw">extern</span> <span class="string">&quot;C&quot;</span> <span class="kw">fn</span>(<span class="ident">ctx</span>: <span class="kw-2">*mut</span> <span class="ident">_Unwind_Context</span>, <span class="ident">arg</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>) -&gt; <span class="ident">_Unwind_Reason_Code</span>;

    <span class="kw">extern</span> <span class="string">&quot;C&quot;</span> {
        <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">_Unwind_Backtrace</span>(
            <span class="ident">trace</span>: <span class="ident">_Unwind_Trace_Fn</span>,
            <span class="ident">trace_argument</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
        ) -&gt; <span class="ident">_Unwind_Reason_Code</span>;
    }

    <span class="macro">cfg_if::cfg_if!</span> {
        <span class="comment">// available since GCC 4.2.0, should be fine for our purpose</span>
        <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(
            <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;android&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>)),
            <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;freebsd&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>)),
            <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>)),
            <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;horizon&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>))
        ))]</span> {
            <span class="kw">extern</span> <span class="string">&quot;C&quot;</span> {
                <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">_Unwind_GetIP</span>(<span class="ident">ctx</span>: <span class="kw-2">*mut</span> <span class="ident">_Unwind_Context</span>) -&gt; <span class="ident">libc::uintptr_t</span>;
                <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">_Unwind_FindEnclosingFunction</span>(<span class="ident">pc</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">c_void</span>;

                <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;s390x&quot;</span>)))]</span>
                <span class="comment">// This function is a misnomer: rather than getting this frame&#39;s</span>
                <span class="comment">// Canonical Frame Address (aka the caller frame&#39;s SP) it</span>
                <span class="comment">// returns this frame&#39;s SP.</span>
                <span class="comment">//</span>
                <span class="comment">// https://github.com/libunwind/libunwind/blob/d32956507cf29d9b1a98a8bce53c78623908f4fe/src/unwind/GetCFA.c#L28-L35</span>
                <span class="attribute">#[<span class="ident">link_name</span> <span class="op">=</span> <span class="string">&quot;_Unwind_GetCFA&quot;</span>]</span>
                <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_sp</span>(<span class="ident">ctx</span>: <span class="kw-2">*mut</span> <span class="ident">_Unwind_Context</span>) -&gt; <span class="ident">libc::uintptr_t</span>;

            }

            <span class="comment">// s390x uses a biased CFA value, therefore we need to use</span>
            <span class="comment">// _Unwind_GetGR to get the stack pointer register (%r15)</span>
            <span class="comment">// instead of relying on _Unwind_GetCFA.</span>
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;linux&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;s390x&quot;</span>))]</span>
            <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">get_sp</span>(<span class="ident">ctx</span>: <span class="kw-2">*mut</span> <span class="ident">_Unwind_Context</span>) -&gt; <span class="ident">libc::uintptr_t</span> {
                <span class="kw">extern</span> <span class="string">&quot;C&quot;</span> {
                    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">_Unwind_GetGR</span>(<span class="ident">ctx</span>: <span class="kw-2">*mut</span> <span class="ident">_Unwind_Context</span>, <span class="ident">index</span>: <span class="ident">libc::c_int</span>) -&gt; <span class="ident">libc::uintptr_t</span>;
                }
                <span class="ident">_Unwind_GetGR</span>(<span class="ident">ctx</span>, <span class="number">15</span>)
            }
        } <span class="kw">else</span> {
            <span class="comment">// On android and arm, the function `_Unwind_GetIP` and a bunch of</span>
            <span class="comment">// others are macros, so we define functions containing the</span>
            <span class="comment">// expansion of the macros.</span>
            <span class="comment">//</span>
            <span class="comment">// TODO: link to the header file that defines these macros, if you</span>
            <span class="comment">// can find it. (I, fitzgen, cannot find the header file that some</span>
            <span class="comment">// of these macro expansions were originally borrowed from.)</span>
            <span class="attribute">#[<span class="ident">repr</span>(<span class="ident">C</span>)]</span>
            <span class="kw">enum</span> <span class="ident">_Unwind_VRS_Result</span> {
                <span class="ident">_UVRSR_OK</span> <span class="op">=</span> <span class="number">0</span>,
                <span class="ident">_UVRSR_NOT_IMPLEMENTED</span> <span class="op">=</span> <span class="number">1</span>,
                <span class="ident">_UVRSR_FAILED</span> <span class="op">=</span> <span class="number">2</span>,
            }
            <span class="attribute">#[<span class="ident">repr</span>(<span class="ident">C</span>)]</span>
            <span class="kw">enum</span> <span class="ident">_Unwind_VRS_RegClass</span> {
                <span class="ident">_UVRSC_CORE</span> <span class="op">=</span> <span class="number">0</span>,
                <span class="ident">_UVRSC_VFP</span> <span class="op">=</span> <span class="number">1</span>,
                <span class="ident">_UVRSC_FPA</span> <span class="op">=</span> <span class="number">2</span>,
                <span class="ident">_UVRSC_WMMXD</span> <span class="op">=</span> <span class="number">3</span>,
                <span class="ident">_UVRSC_WMMXC</span> <span class="op">=</span> <span class="number">4</span>,
            }
            <span class="attribute">#[<span class="ident">repr</span>(<span class="ident">C</span>)]</span>
            <span class="kw">enum</span> <span class="ident">_Unwind_VRS_DataRepresentation</span> {
                <span class="ident">_UVRSD_UINT32</span> <span class="op">=</span> <span class="number">0</span>,
                <span class="ident">_UVRSD_VFPX</span> <span class="op">=</span> <span class="number">1</span>,
                <span class="ident">_UVRSD_FPAX</span> <span class="op">=</span> <span class="number">2</span>,
                <span class="ident">_UVRSD_UINT64</span> <span class="op">=</span> <span class="number">3</span>,
                <span class="ident">_UVRSD_FLOAT</span> <span class="op">=</span> <span class="number">4</span>,
                <span class="ident">_UVRSD_DOUBLE</span> <span class="op">=</span> <span class="number">5</span>,
            }

            <span class="kw">type</span> <span class="ident">_Unwind_Word</span> <span class="op">=</span> <span class="ident">libc::c_uint</span>;
            <span class="kw">extern</span> <span class="string">&quot;C&quot;</span> {
                <span class="kw">fn</span> <span class="ident">_Unwind_VRS_Get</span>(
                    <span class="ident">ctx</span>: <span class="kw-2">*mut</span> <span class="ident">_Unwind_Context</span>,
                    <span class="ident">klass</span>: <span class="ident">_Unwind_VRS_RegClass</span>,
                    <span class="ident">word</span>: <span class="ident">_Unwind_Word</span>,
                    <span class="ident">repr</span>: <span class="ident">_Unwind_VRS_DataRepresentation</span>,
                    <span class="ident">data</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
                ) -&gt; <span class="ident">_Unwind_VRS_Result</span>;
            }

            <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">_Unwind_GetIP</span>(<span class="ident">ctx</span>: <span class="kw-2">*mut</span> <span class="ident">_Unwind_Context</span>) -&gt; <span class="ident">libc::uintptr_t</span> {
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">val</span>: <span class="ident">_Unwind_Word</span> <span class="op">=</span> <span class="number">0</span>;
                <span class="kw">let</span> <span class="ident">ptr</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">val</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">_Unwind_Word</span>;
                <span class="kw">let</span> <span class="kw">_</span> <span class="op">=</span> <span class="ident">_Unwind_VRS_Get</span>(
                    <span class="ident">ctx</span>,
                    <span class="ident">_Unwind_VRS_RegClass::_UVRSC_CORE</span>,
                    <span class="number">15</span>,
                    <span class="ident">_Unwind_VRS_DataRepresentation::_UVRSD_UINT32</span>,
                    <span class="ident">ptr</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
                );
                (<span class="ident">val</span> <span class="op">&amp;</span> <span class="op">!</span><span class="number">1</span>) <span class="kw">as</span> <span class="ident">libc::uintptr_t</span>
            }

            <span class="comment">// R13 is the stack pointer on arm.</span>
            <span class="kw">const</span> <span class="ident">SP</span>: <span class="ident">_Unwind_Word</span> <span class="op">=</span> <span class="number">13</span>;

            <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">get_sp</span>(<span class="ident">ctx</span>: <span class="kw-2">*mut</span> <span class="ident">_Unwind_Context</span>) -&gt; <span class="ident">libc::uintptr_t</span> {
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">val</span>: <span class="ident">_Unwind_Word</span> <span class="op">=</span> <span class="number">0</span>;
                <span class="kw">let</span> <span class="ident">ptr</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">val</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">_Unwind_Word</span>;
                <span class="kw">let</span> <span class="kw">_</span> <span class="op">=</span> <span class="ident">_Unwind_VRS_Get</span>(
                    <span class="ident">ctx</span>,
                    <span class="ident">_Unwind_VRS_RegClass::_UVRSC_CORE</span>,
                    <span class="ident">SP</span>,
                    <span class="ident">_Unwind_VRS_DataRepresentation::_UVRSD_UINT32</span>,
                    <span class="ident">ptr</span> <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">c_void</span>,
                );
                <span class="ident">val</span> <span class="kw">as</span> <span class="ident">libc::uintptr_t</span>
            }

            <span class="comment">// This function also doesn&#39;t exist on Android or ARM/Linux, so make it</span>
            <span class="comment">// a no-op.</span>
            <span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">_Unwind_FindEnclosingFunction</span>(<span class="ident">pc</span>: <span class="kw-2">*mut</span> <span class="ident">c_void</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">c_void</span> {
                <span class="ident">pc</span>
            }
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="backtrace" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>